/*
 * Licensed Materials - Property of IBM
 * IBM Sterling Field Sales
 * (C) Copyright IBM Corp. 2009, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */
 
Ext.namespace('sc.sfs.container');

sc.sfs.container.AppContainer = function(config) {
	Ext.apply(this, config);
	this.addEvents(
		'beforescreenadd',
		'beforescreenrender',
		'afterscreenadd',
		'afterscreenrender'
	);
	sc.sfs.container.AppContainer.superclass.constructor.call(this, config);
};

Ext.extend(sc.sfs.container.AppContainer, sc.plat.ui.ExtensibleScreen, {
			className : 'sc.sfs.container.AppContainer',
			titleTemplate : new Ext.Template(
							'<table width="100%">'+
								'<tr>'+
									//'<td class="app-title">' +
									//	sc.plat.bundle["Sterling_Field_Sales"] +
									//'</td>' +
									'<td align="left" style="width:100%;"><span class="app-name">'+sc.plat.bundle["b_FieldSales"]+'</span>' +
									'</td>' +
									'<td class="app-user-name">'+
										'<span>' + sc.plat.Userprefs.getUserName() +'</span>' +
									    '&nbsp;&nbsp;' +	    
									'</td>' +
									'<td class="app-user-help-actions">'+									    
										'<div id="helpMenu"></div>'+
									'</td>' +
										
									'<td class="app-user-actions">'+
										'<a id="sfsuserpreflink" class="hasright" href="#" onclick="sc.sfs.helper.UIUserPrefHelper.loadOptions()">' + sc.plat.bundle["b_Preferences"] +'</a>'+
										'<a href="/'+sc.plat.info.Application
										.getApplicationContext() +'/sfs/logout.do' + '">' + sc.plat.bundle["b_Sign_out"] +'</a>' +
									'</td>' +
									'<td><div class="app-logo"></div></td>'+
								'</tr>'+
							'</table>'
						).compile(),
			titlePanelListner : function() {
				return {

					'render' : function(pnl) {

						var tpl1 = this.titleTemplate;

						var el = pnl.body.createChild({
									tag : 'div',
									id : 'top-panel'
								});

						el.dom.innerHTML = tpl1.apply({});

					},
					'afterrender' : function(pnl){
							this.showHelpMenu("helpMenu");
					},
					scope : this
				}
			},
			drawScreen : function(screen, initialScreenConfig) {
				if (!screen) {
					throw "screen should be passed.";
				}
				var screenConfig = sc.sfs.helper.ScreenHelper
						.processScreenConfig(screen, initialScreenConfig);
				// fire an event beforeload to stop the screen Load
				var backRequired = screenConfig
						? screenConfig.backRequired
						: false;
				var cacheRequired = initialScreenConfig
                                    ? (initialScreenConfig.cacheRequired === false) ? initialScreenConfig.cacheRequired: true 
                                    : true;
                                    
                if(screenConfig){
                	screenConfig.cacheRequired = cacheRequired;
                }

				this.loadScreen(screen, backRequired, cacheRequired);
				sc.app.common.core.context.UIContext.setCurrentScreen(screen,
						screenConfig, initialScreenConfig);
				sc.sfs.helper.ScreenHelper.applyScreenConfig(screen,
						screenConfig);
				this.doLayout();
			},
			loadScreen : function(screen, backRequired, cacheRequired){
				var screenPanel = sc.sfs.util.containerUtil.getScreenPanel();
				var activeItem = screenPanel.getLayout().activeItem;
				if(!backRequired && activeItem){
					// fire an event passing new and old
		
					screenPanel.remove(activeItem);
					// fire and event passsing new
					sc.app.common.core.context.UIContext.removeScreen(activeItem);
				}
				if (!cacheRequired)     {
					  screenPanel.remove(activeItem);
                      sc.app.common.core.context.UIContext.removeScreen(activeItem);
                }
                if(this.fireEvent('beforescreenadd', this, screen, screenPanel) !== false){                	
					screenPanel.add(screen);
					this.fireEvent("afterscreenadd", this, screen, screenPanel);                
	                if(this.fireEvent('beforescreenrender', this, screen, screenPanel) !== false){
						screenPanel.getLayout().setActiveItem(screen.getItemId());
						this.doLayout();
						this.fireEvent("afterscreenrender", this, screen, screenPanel); 						
	                }
                }			
		},
		/*
		 * following parameter are passed in scope to this method 
		 */
		switchOrg : function(){

			sc.plat.FormUtils.request({
			 url : sc.sfs.helper.AppHelper.getURLWithContainer("sfsHome", sc.sfs.App.GlobalStrutsNS),			 
			 params : {
			 		"orgDetailsInputNs" : Ext.encode(this.organization)
			 }
			});
			// if current screen is not Home &  dirty show a message that current changes will be lost...
			
			
			
	
		},
		showHelpMenu : function(ownerDiv ){
			var menu = this.getHelpMenu();
			var btn = new Ext.ux.LinkButton({
				text : sc.plat.bundle["b_Help"] ,
				menu : menu,
			 template: new Ext.Template(
			        '<table cellspacing="0" class="x-btn-link {3}"><tbody class="{4}">',
			          /* '<tr>',
			                '<td class="x-btn-link-tl"><i>&#160; </i></td>',
			                '<td class="x-btn-link-tc"></td>',
			                '<td class="x-btn-link-tr"><i>&#160; </i></td>',
			            '</tr>', */
			            '<tr>',
			              //'<td class="x-btn-link-ml"><i>&#160; </i></td>', 
			                '<td class="x-btn-link-mc">',
			                    '<em class="{5}" unselectable="on">',
			                        '<a href="{6}" style="display:block" target="{7}" class="x-btn-text {2}" style="text-decoration: none; color: black; padding-left: 3px; padding-right: 3px;"><span>{0}</span></a>',
			                    '</em>',
			                '</td>',
			             //   '<td class="x-btn-link-mr"><i>&#160; </i></td>', 
			            '</tr>',
			           /* '<tr>',
			                '<td class="x-btn-link-bl"><i>&#160; </i></td>',
			                '<td class="x-btn-link-bc"></td>',
			                '<td class="x-btn-link-br"><i>&#160; </i></td>',
			            '</tr>', */
			        '</tbody></table>'
			    ).compile(),
				renderTo : ownerDiv,
				menuAlign : 'tr-br?'
			}); 
		},
		getHelpMenu : function(){
				menu = new Ext.menu.Menu({cls : "x-help-menu"});
				this.addOnlineHelpSubMenu(menu);
				this.addDocLibHelpSubMenu(menu);
				this.addAboutBox(menu);
				return menu;
		},
		addOnlineHelpSubMenu : function(menu){
			cfg = {
				handler : sc.sfs.helper.OnlineHelpLauncher.loadHelpWindow,
				text : sc.plat.bundle["b_Context_Sensitive_Help"] || "Context-sensitive Help"
			}
			var item = new Ext.menu.Item(cfg);
			menu.add(item);
		},
		addDocLibHelpSubMenu : function(menu){
			cfg = {
				handler : sc.sfs.helper.OnlineHelpLauncher.loadOnlineDocumentationLibrary,
				scope : sc.sfs.helper.OnlineHelpLauncher,
				text : sc.plat.bundle["b_Doc_Library"] 
			}
			var item = new Ext.menu.Item(cfg);
			menu.add(item);
		},
		addAboutBox : function(menu){
			cfg = {
				handler : sc.sfs.helper.AboutBoxLauncher.loadAboutBoxWindow,
				scope : sc.sfs.helper.AboutBoxLauncher,
				text : sc.plat.bundle["b_aboutTitle"]
			}
			var item = new Ext.menu.Item(cfg);
			menu.add(item);
		},
		launchOnlineHelp : function(){
			
		},
		getUIConfig : sc.sfs.container.AppContainerUIConfig

		});
Ext.reg('sfscontainer', sc.sfs.container.AppContainer);
