/*
 * Licensed Materials - Property of IBM
 * IBM Sterling Field Sales
 * (C) Copyright IBM Corp. 2009, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */
 
Ext.namespace("sc.sfs.helper")

sc.sfs.helper.MenuHelper = function(){
	
	var menuPanel;
	var menuoptions;
	
	return{
		
		renderDefaultMenu: function(menuPanelId ,container){
			if(!container){
				container = sc.sfs.util.containerUtil.getAppContainer();
			}
			menuPanel = sc.app.common.util.PlatUtils.getItemBySciId(container, menuPanelId);
			if(!menuPanel){
				menuPanel = Ext.getCmp(menuPanelId);
			}
			if(!menuPanel){
				 menuPanel = sc.app.common.util.PlatUtils.getItemBySciId(container, "sfsMenuPanel");
			}
			sc.plat.Menupaint.renderMenu(menuPanel.getId());
			//menuPanel.addClass("sfs-menu-panel");
			var btn = sfsSavedSearchUtils.getSavedSearchPnl({renderTo:"headersavedsearchcombo"});
			this.addMenu(btn, "end");			
		},		
		setHeight: function(height)	{
			var menuToolBar;
			var el = menuPanel.getEl();
			var toolBarDom = el.dom.childNodes[1];
			if(toolBarDom){
				menuToolBar = Ext.getCmp(toolBarDom.id);				
			}
			menuToolBar.setHeight(height);
		},
		addBorder: function( menudata,position)	{
			var menuToolBar;
			var el = menuPanel.getEl();
			var toolBarDom = el.dom.childNodes[1];
			if(toolBarDom){
				menuToolBar = Ext.getCmp(toolBarDom.id);				
			}
			if(position == "end"){
				menuToolBar.addButton(menudata);
			}
			if(position == "first"){
				menuToolBar.insertButton(0,menudata);
			}		
		},
		addMenu: function( menudata, position){
			var menuToolBar;
			var el = menuPanel.getEl();
			var toolBarDom = el.dom.childNodes[1];
			if(toolBarDom){
				menuToolBar = Ext.getCmp(toolBarDom.id);
				
			}
			if(position == "end"){
				menuToolBar.add("->");
			}
			if(position == "first"){
				menuToolBar.insertButton(0,menudata);
			}	else	{
				menuToolBar.add( " " , " ", " ",  menudata);
			}
			menuToolBar.doLayout();
			
		},
		renderAppMenu : function(menuPanelId ,container){
				this.renderDefaultMenu(menuPanelId, container);
		},
		getMenuFromSciId : function(sciId){
			var menuToolBar;
			var menu;
			var el = menuPanel.getEl();
			var toolBarDom = el.dom.childNodes[1];
			if(toolBarDom){
				menuToolBar = Ext.getCmp(toolBarDom.id);
				menuToolBar.items.each(function(item){
		             if(item.sfsParentMenu && item.sciId == sciId ){
		                 menu = item;
	             	 }
			     });	
			}
			return menu;
		},
		getAllMenu : function(){
			var menuToolBar;
			var menus = [];
			var el = menuPanel.getEl();
			var toolBarDom = el.dom.childNodes[1];
			if(toolBarDom){
				menuToolBar = Ext.getCmp(toolBarDom.id);
				menuToolBar.items.each(function(item){
		             if(item.sfsParentMenu){
		                 menus.push(item);
	             	 }
			     });	
			}
			return menus;
		},
		setActiveMenu : function(sciId){
			/*var menuToolBar;
			var menu;
			var el = menuPanel.getEl();
			var toolBarDom = el.dom.childNodes[1];
			if(toolBarDom){
				menuToolBar = Ext.getCmp(toolBarDom.id);
				menuToolBar.items.each(function(item){
		             if(item.sfsParentMenu  ){
		             	if(item.sciId == sciId ){
		             		if(item.rendered){
		                	 	item.setActiveMenu(true);
		             		}else{
		             			item.activeMenu = true;
		             		}
		             	}else{
			             	if(item.rendered){
		             	 		item.setActiveMenu(false);
		             	 	}else{
		             	 		item.activeMenu = false;
		             	 	}
		            	 }
		             }
			     });	
			}*/
		},

		renderNewMenu : function(menuPanelId ,container)	{
			if(!container){
				container = sc.sfs.util.containerUtil.getAppContainer();
			}
			menuPanel = sc.app.common.util.PlatUtils.getItemBySciId(container, menuPanelId);
			if(!menuPanel){
				menuPanel = Ext.getCmp(menuPanelId);
			}
			if(!menuPanel){
				 menuPanel = sc.app.common.util.PlatUtils.getItemBySciId(container, "sfsMenuPanel");
			}
			var menuString = this.populateNewMenu();
			var savedSearchString = this.savedSearchCombo();
			var basemenupanel = '<div>' +
									'<ul class="app-menu-items">' +
										menuString + 
									'</ul>'	+
									'<ul style="float:right;">' +
										savedSearchString +
									'</ul>'	+
								'</div>';

			var tpl = new Ext.Template(basemenupanel);
			var el1 = menuPanel.body.createChild({
				tag : 'div',
				id : 'menu'
			});
			el1.dom.innerHTML = tpl.apply({});			
			el1.addClass("app-base-menu-panel");
/*			var el2 = menuPanel.body.createChild({
				tag : 'div',
				id : 'menu'
			});
			el2.addClass("app-menu-panel");*/
			menuPanel.doLayout();
			var savedSearchScreen = sfsSavedSearchUtils.getSavedSearchPnl({renderTo:"headersavedsearchcombo"});
			menuPanel.doLayout();
			
		},
		renderSFSMenu : function(menuPanelId ,container)	{
			if(!container){
				container = sc.sfs.util.containerUtil.getAppContainer();
			}
			menuPanel = sc.app.common.util.PlatUtils.getItemBySciId(container, menuPanelId);
			if(!menuPanel){
				menuPanel = Ext.getCmp(menuPanelId);
			}
			if(!menuPanel){
				 menuPanel = sc.app.common.util.PlatUtils.getItemBySciId(container, "sfsMenuPanel");
			}
			var leftborder = '<table cellspacing="0" cellpadding="0" border="0" width="100%">'
					+ '<tbody>'
					+ '<tr>'
					+ '<td class="sfs-menu-left-border">'
					+ '</td>';
			var rightborder = '<td class="sfs-menu-right-border">'
					+ '</td>'
					+ '</tr>'
					+ '</tbody>'
					+ '</table>';

			var menuString = this.populateMenu();
			var savedSearchString = this.savedSearchCombo();
			//var tpl = new Ext.Template(leftborder+menuString+savedSearchString+rightborder);
			var tpl = new Ext.Template(leftborder+menuString+rightborder);
			var el1 = menuPanel.body.createChild({
				tag : 'div',
				id : 'menu'
			});
			el1.addClass("menu-base-panel");
			el1.dom.innerHTML = tpl.apply({});			
			menuPanel.doLayout();
			var savedSearchScreen = new sc.sfs.search.GetSavedSearch({renderTo:"headersavedsearchcombo"});
			menuPanel.doLayout();
		},
		savedSearchCombo : function()	{
			/*var cmb = '<div id="headersavedsearchcombo" class="x-form-field-wrap x-form-field-trigger-wrap app-menu-saved-search-panel">'
			+ 'Saved Searches: <input id="searches" class=" x-form-text x-form-field x-form-empty-field" type="text" size="25" autocomplete="off"/>'
			+ '<img id="ext-gen10" class="x-form-trigger x-form-arrow-trigger" src="/sfs/platform/icons/s.gif" />'
			+ '</div>';*/
			var cmb = '<div id="headersavedsearchcombo"></div>';
			return cmb;

		},
		populateNewMenu : function()	{
			var menuString='';
			var json = jsonMenu.subMenu;
			if(!json){
				return;
			}
			var i, menu, m, cfg, subM, len = json.length;
			for (i =0;i<len;i++) {
				m = json[i];
				if(typeof m == "string" || typeof m == "function" || m.text == "undefined"){
					continue;
				}
				menuString = menuString + '<li class="app-menu-item" onmouseover="sc.sfs.helper.MenuHelper.mopen(\''+i+'\')" onmouseout="sc.sfs.helper.MenuHelper.mopen(\'\')">';
				menuString = menuString + '<a class="app-menu-item-url ' + m.img + '" href="javascript:sc.sfs.helper.AppHelper.loadContainerURL(\'' + m.url + '\')">';
				menuString = menuString + '<span class="app-menu-item-text">'+m.text+'</span></a>';

				subM = m.subMenu;
				if (subM) {
					menuString = menuString + '<span class="app-menu-drop-down">&nbsp;&nbsp;&nbsp;</span>';
					menuString = menuString + this.populateNewSubMenu(subM,i);
				}
				menuString = menuString + '</li>';

			}
			menuoptions=len;
			return menuString;

		},
		populateNewSubMenu: function(subM,id)	{
			var submenustring = '';
			
			submenustring = submenustring + '<ul class="app-sub-menu-items" id="menu_'+id+'">';

			var cfg, item, i, m, len = subM.length;
			for (i = 0; i < len; i++) {
				m = subM[i];
				submenustring = submenustring + '<li class="app-sub-menu-item">';
				if( m.url ){
					submenustring = submenustring + '<a class="app-sub-menu-item-url" href="' + m.url + '">' + m.text + '</a></li>';
				}else{
					submenustring = submenustring + '<a class="app-sub-menu-item-url" href="#" onclick="'+m.js+'">' + m.text + '</a></li>';
				}
			}

			submenustring = submenustring + '</ul>';

			return submenustring;
		},
		populateMenu : function() {
			var menuString='<td><div class="menu-table"><table class="menu-table-nav-buttons" cellspacing="0" cellpadding="0" border="0"><tbody><tr>';
			var json = jsonMenu.subMenu;
			if(!json){
				return;
			}
			var i, menu, m, cfg, subM, len = json.length;
			for (i =0;i<len;i++) {
				m = json[i];
				if(typeof m == "string" || typeof m == "function" || m.text == "undefined"){
					continue;
				}

				switch (i) {
					case 0:
						menuString = menuString + '<td class="no-border-left">';
						menuString = menuString + '<a href="'+m.url+'"><img class="sfs-home" src="/sfs/sfs/resources/default/icons/home.png"></img>' + sc.plat.bundle[m.text] + '</a>';
						break;
					case len-1:
						menuString = menuString + '<td>';
						menuString = menuString + '<a href="'+m.url+'"><img class="sfs-home" src="/sfs/sfs/resources/default/icons/help.png"></img>' + sc.plat.bundle[m.text] + '</a>';
						break;
					case 1:
						menuString = menuString + '<td class="menu-selected" onmouseout="sc.sfs.helper.MenuHelper.mclose(\'Quote\')"  onmouseover="sc.sfs.helper.MenuHelper.mopen(\'Quote\')">';
						menuString = menuString + '<a href="'+m.url+'"><img class="sfs-home" src="/sfs/sfs/resources/default/icons/opps.png"></img>' + sc.plat.bundle[m.text] + '</a>';
						break;
					default:
						menuString = menuString + '<td>';
						menuString = menuString + '<a href="'+m.url+'"><img class="sfs-home" src="/sfs/sfs/resources/default/icons/quote.png"></img>' + sc.plat.bundle[m.text] + '</a>';
						break;
				}	
				subM = m.subMenu;
				if (subM) {
					menuString = menuString + this.populateSubMenu(subM,m.text);
				}

				menuString = menuString + '</td>';

			}
			menuString = menuString + '</tr></tbody></table></div></td>';
			return menuString;
		},
		populateSubMenu: function(subM,id)	{
			var  k = '<div id="'+id+'" class="submenu-panel" style="visibility: hidden; display: none;">'
					+ '<table cellspacing="0" cellpadding="0" border="0" align="left">'
					+ '<tbody><tr><td>'
					+ '<table id="mgDdRht" width="135" cellspacing="0" cellpadding="0" border="0"><tbody>';

			var cfg, item, i, m, len = subM.length;
			for (i = 0; i < len; i++) {
				m = subM[i];
				k = k + '<tr><td class="submenu-table-nav-item">';
				if( m.url != "undefined"){
					k = k + '<a class="submenu-table-nav-buttons" href="#">' + m.text + '</a>';
				}else{
					k = k + '<a class="submenu-table-nav-buttons" href="#" onclick="'+sc.sfs.helper.MenuHelper.getMenuFn(subM)+'">' + m.text + '</a>';
				}
					k = k + '</td></tr>';	
			}

			k = k + '</tbody></table>'
					+ '</td></tr></tbody>'
					+ '</table>'
					+ '</div>';
			return k;
		},
		getMenuString: function(i, m, len)	{
		},
		getMenuFn: function(menu) {
			var fn;
			if (menu.js) { // TD -175709
				fn = function(menu) {
					return function() {
						eval(menu.js);
					};
				}(menu);
			} else {
				fn = function(menu) {
					return function() {
						sc.plat.FormUtils.request({
									url : menu.url,
									method : 'GET'
								});
					};
				}(menu);
			}
			return fn;
		},
		mopen: function(id)
		{
			for (i =0;i<menuoptions;i++) {
				var d = Ext.get('menu_'+i);
				if (d!=null)
				{
					if (i==id)
					{
						if (d.getStyle("visibility")==="visible")
						{
							d.setStyle("visibility","hidden");
							d.setStyle("display","none");
						}	else	{
							d.setStyle("visibility","visible");
							d.setStyle("display","block");
						}
					}	else	{
						d.setStyle("visibility","hidden");
						d.setStyle("display","none");
					}
				}
			}
		},
		mclose: function(id)
		{
			var d = Ext.get(id);
			d.setStyle("visibility","hidden");
			d.setStyle("display","none");
		} 
 		
	};
	
}();
