/*
 * Licensed Materials - Property of IBM
 * IBM Sterling Field Sales
 * (C) Copyright IBM Corp. 2010, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */
 

Ext.ns("sc.sfs.window")
sc.sfs.window.launchUserPrefOptionAction = new sc.app.common.core.action.LaunchWindowAction({
		
	handler : function(config){
			sc.app.common.util.UIWindowAjaxUtils.request({
				action : "loaduserprefscreen",
				actionNS : "/sfs",
				sfsScopeParams : config
			});
		}    
});
sc.app.common.core.register.WindowActionRegistry.register("userprefoptions", sc.sfs.window.launchUserPrefOptionAction);

Ext.namespace("sc.sfs.helper");


Ext.namespace("sc.sfs.core.action");

sc.sfs.core.action.GlobalRelatedTaskAction = new Ext.Action( {
	handler : function(screen, opt) {
		var handler = sc.sfs.util.containerUtil.handleTaskButtonClick;
		Ext.callback(handler,sc.sfs.util.containerUtil);
	}
});

sc.app.common.core.register.GlobalButtonRegistry.registerAction("relatedTaskAction", sc.sfs.core.action.GlobalRelatedTaskAction);

sc.sfs.helper.UIUserPrefHelper = function(){

	return {		
		loadOptions : function(){
			sc.app.common.util.PlatUtils.handleDirty(sc.sfs.helper.UIUserPrefHelper.loadAfterDirtyCheck, null, null, sc.sfs.helper.UIUserPrefHelper,"isChkRequiredForScreenUnload");
		},
		loadAfterDirtyCheck : function(){
			sc.app.common.util.LoadEntityUtils.loadPopupWithSaveAndClose({
				action : "loaduserprefscreen",
				actionNS : "sfs",
				parentScr : sc.sfs.util.containerUtil.getContainerPanel(),
				field : "sfsuserpreflink",
				savefn : this.selectionHandler,
				entity : "userprefoptions",
				windowConfig : {title: sc.plat.bundle["b_Preferences"]},
				scope : this
			});
		},
		selectionHandler : function(data, screen, parentScr, win){
			if(!screen.isDirty(true)){
				return true;
			}else if(!screen.isDelegatePanelDirty()){						
				var input = screen.getAPIInput();
				sc.app.common.util.DataAjaxUtils.request({
					action : "manageuseruipref",
					actionNS : "/sfs",
					params:{"userUIPref_Input":Ext.encode(input[0])},
					success : this.aferSuccess,
					scope : this,
					win :win
				});
				return false;
			}else{
				if(!screen.isDelegateSet()){			
					var errorObj = {};
					errorObj.em = sc.app.common.util.MessagesUtil.getRequiredFieldText("b_blankDelegateWarningText");
					errorObj.type = 1;
					sc.plat.RequestUtils.handleErrors(errorObj);
					return false;
				}else if(!screen.areDatesSet()){			
					var errorObj = {};
					errorObj.em = sc.plat.bundle["b_blankDatesWarningText"];
					errorObj.type = 1;
					sc.plat.RequestUtils.handleErrors(errorObj);
					return false;
				}else if(screen.hasDateElapsed()){			
					var errorObj = {};
					errorObj.em = sc.plat.bundle["b_EndDatePassed"];
					errorObj.type = 1;
					sc.plat.RequestUtils.handleErrors(errorObj);
					return false;
				}else{						
					var input = screen.getAPIInput();
					sc.app.common.util.DataAjaxUtils.request({
						action : "manageuseruipref",
						actionNS : "/sfs",
						params:{"userUIPref_Input":Ext.encode(input[0]),
						"getUserHierarchy_Input":Ext.encode(input[1])},
						success : this.aferSuccess,
						scope : this,
						win :win
					});
					return false;
				}
			}
		},
		aferSuccess : function(res, options){
			var url =  sc.sfs.helper.AppHelper.getURLForWindowHref(sc.sfs.core.context.AppContext.getHomePage());
			sc.plat.FormUtils.request({
			url : url,
			method : 'POST'
			});
			/*options.win.close();
			var hideNavPanelPref = sc.plat.DataUtils.extractData(options, "inputObj.UserUiState.Definition");
			if(sc.app.common.util.PlatUtils.getBoolean(hideNavPanelPref)){
				sc.sfs.core.context.AppContext.setHideNavPanelPref(true);
				
			}else{
				sc.sfs.core.context.AppContext.setHideNavPanelPref(false);
			}	
			sc.sfs.util.containerUtil.handlePrefChange(sc.app.common.util.PlatUtils.getBoolean(hideNavPanelPref));*/
		}
	};
}();