<%
// Licensed Materials - Property of IBM
// IBM Sterling Field Sales
// (C) Copyright IBM Corp. 2009, 2012 All Rights Reserved.
// US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
%>
<%@page import="java.util.HashMap"%>
<%@page import="java.util.Iterator"%>
<%@page import="java.util.List"%>
<%@page import="java.lang.StringBuffer"%>

<%@page import="org.w3c.dom.Element"%>
<%@page import="org.w3c.dom.NamedNodeMap"%>
<%@page import="org.w3c.dom.Node"%>

<%@page import="com.sterlingcommerce.framework.utils.SCXmlUtils"%>
<%@page import="com.sterlingcommerce.ui.web.framework.SCUIException"%>
<%@page import="com.sterlingcommerce.ui.web.framework.context.SCUIContext"%>
<%@page import="com.sterlingcommerce.ui.web.framework.helpers.SCUIMashupHelper"%>
<%@page import="com.sterlingcommerce.ui.web.framework.utils.SCUIContextHelper"%>
<%@page import="com.sterlingcommerce.ui.web.framework.utils.SCUIJSONUtils"%>
<%@page import="com.sterlingcommerce.ui.web.framework.utils.SCUIUtils"%>
<%@page import="com.sterlingcommerce.ui.web.framework.dashboard.*"%>
<%@page import="com.sterlingcommerce.security.dv.SCEncoder"%>
<%@page import="com.sterlingcommerce.ui.web.platform.SCUIImplConstants"%>


<%
SCUIContext uiContext = SCUIContextHelper.getUIContext(request, response);
String dashboardid = request.getParameter("dashboardid");
String dashletid = request.getParameter("dashletid");
if(dashboardid == null){
    dashboardid = "";
}
if(dashletid == null){
    dashletid = "";
}
Element chartElement = null;
Element groupData=null;
String chartType="";
boolean hasError=false;
try{
	Element dashlet = SCUIDashboardManager.getInstance(SCUIUtils.getApplicationId(uiContext)).getDashlet(SCEncoder.getEncoder().encodeForJavaScript(dashletid), SCEncoder.getEncoder().encodeForJavaScript(dashboardid), uiContext);
	Element dashletConfig = SCXmlUtils.getChildElement(dashlet, "Config");
	Element dataSources = SCXmlUtils.getChildElement(dashletConfig, "Datasources");
	chartElement = SCXmlUtils.getChildElement(dashletConfig, "Chart");

	chartType = chartElement.getAttribute("chartType");

	Element datatSource = null;
	datatSource = SCXmlUtils.getChildrenList(dataSources).get(0);
	String labelpath = (String) datatSource.getAttribute("labelpath");
	String valuepath = (String) datatSource.getAttribute("valuepath");
	String mashupId = datatSource.getAttribute("mashupId");
	groupData = (Element) SCUIMashupHelper.invokeMashup(mashupId, datatSource, uiContext);
}catch(Exception ex){
	ex.printStackTrace();
	hasError=true;
}
%>

function createBody(pnl) {
    var chartPanel = new Ext.Panel({
        bodyBorder: false,
		bodyCssClass:"opp-dashlet",
        border: false,
		header: false,
        layout: "anchor",
		sctype:"GroupPanel"
    });

<% if(hasError){%>
	var errorLabel = new Ext.form.Label({
						text : sc.plat.bundle["b_dashletException"],
						cls:"sfs-dashleterror",
						ctCls:"sfs-dashleterror"
					});
	chartPanel.add(errorLabel);	
	return chartPanel;
<%}else{%>
	var chartXml = "<chart" + 
		<%
			boolean hasData = false;
			NamedNodeMap attrs = chartElement.getAttributes();
			for (int i = 0; i < attrs.getLength(); i += 1) {
				Node attr = attrs.item(i);
		%>
				' <%=attr.getNodeName()%>="<%=attr.getNodeValue()%>"' +
		<%	}	%>
		' xAxisName="'+sc.plat.bundle["b_Probability"]+'" yAxisName="'+sc.plat.bundle["b_ProbabilityCount"]+'"'+
		<%if(Integer.parseInt(groupData.getAttribute("HighestCount")) <= 1){%>
			'  yAxisMinValue="0" yAxisMaxValue="5" '+
		<%}%>
	" ><styles>"+
		"<definition>"+
			"<style name='Title' type='font' size='12' bold='0' color='#1F497D' />"+
			"<style name='Label' type='font' size='10' bold='0' />"+
			"<style name='toolText' type='font' size='9' bold='0' />"+
			"<style name='bevel' type='Bevel' />"+
		"</definition>"+
		"<application>"+
			"<apply toObject='XAXISNAME' styles='Title' />"+
			"<apply toObject='YAXISNAME' styles='Title' />"+
			"<apply toObject='XAXISVALUES' styles='Label' />"+
			"<apply toObject='YAXISVALUES' styles='Label' />"+
			"<apply toObject='TOOLTIP' styles='toolText' />"+
			"<apply toObject='DataPlot' styles='bevel' />"+
		"</application>"+
	   "</styles>"+

		<%
			for(Iterator<Element> dataSets = SCXmlUtils.getChildren(groupData) ; dataSets.hasNext() ; ){
				hasData=true;
				Element data = dataSets.next();
				String label = data.getAttribute("label");

		%>		
				'<set '+
				<%if(label.startsWith("b_")){%>
					'label="'+sc.plat.bundle["<%=label%>"]+'" '+
				<%}else{%>
					'label="'+String.format(sc.plat.bundle["b_OpportunityGraphRange"], <%=label%>)+'" '+
				<%}%>
				'value="<%=data.getAttribute("OpportunityCount")%>" '+
				'toolText="'+
				<%
				for(Iterator<Element> ents = SCXmlUtils.getChildren(data) ; ents.hasNext() ; ){
					Element enterprise = ents.next();
					if(enterprise.getAttribute("Count")=="1"){%>
						String.format(sc.plat.bundle["b_SingleOppProbCountTooltip"], 
					<%}else{%>
						String.format(sc.plat.bundle["b_SingleOppProbCountTooltip"], 
					<%}%>
					<%=enterprise.getAttribute("Count")%>,
					sc.app.common.util.FormatterUtils.getFormattedCurrency(<%=enterprise.getAttribute("CurrencyValue")%>, 
					"<%=enterprise.getAttribute("Currency")%>"),
					"<%=enterprise.getAttribute("EnterpriseCode")%>")+	
					<%if(ents.hasNext()){%>
						"%0D"+
					<%}%>
				<%}%>
				'" />'+
		<%	}	%>

	"</chart>";

	<%if(hasData){%>
		<%
				String csrfValMode = (String) request.getSession().getAttribute(SCUIImplConstants.CSRF_VALIDATOR_MODE);
				/*
				 * If CSRF token validator is in use, this csrfValMode will have one
				 * of 'ALL', ''NONE', 'POST' values.
				 */
				if (SCUIImplConstants.CSRF_TOKEN_VALIDATOR_REQUEST_METHOD_ALL.equalsIgnoreCase(csrfValMode))
				{ %>
					 var chart = new FusionCharts("<%=request.getContextPath()%>/platform/fusioncharts/<%=chartType%>.swf?scCSRFToken=<%=SCEncoder.getEncoder().encodeForHTML(request.getParameter("scCSRFToken"))%>&scFlag=Y", "OpportunitySuccess", "330", "210", "0", "1");
				<%} 
				else
				{ %>
				    var chart = new FusionCharts("<%=request.getContextPath()%>/platform/fusioncharts/<%=chartType%>.swf?scFlag=Y", "OpportunitySuccess", "330", "210", "0", "1");
				<%}%>
		chart.setDataXML(chartXml);
		chart.setTransparent(true);
		chartPanel.on('render', function(){
			chart.render(chartPanel.body.id);
		});
	    return chartPanel;
	<%}else{%>
		var noDatalabel = new Ext.form.Label({
							text : sc.plat.bundle["b_NoGraphData"],
							cls:"sfs-noresults-text"
						});
		chartPanel.add(noDatalabel);	
		return chartPanel;
	<%}%>
<%}%>
}
