/*
 * Licensed Materials - Property of IBM
 * IBM Sterling Field Sales
 * (C) Copyright IBM Corp. 2010, 2012 All Rights Reserved.
 * US Government Users Restricted Rights - Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
 */

Ext.namespace('sc.sfs.quote.manage.products.configurator');

sc.sfs.quote.manage.products.configurator.ItemConfiguratorPopup = function(config) {
	Ext.apply(this, {inputObj:config});
	Ext.applyIf(config, {width:795, height:440});
    sc.sfs.quote.manage.products.configurator.ItemConfiguratorPopup.superclass.constructor.call(this, config);
}
Ext.extend(sc.sfs.quote.manage.products.configurator.ItemConfiguratorPopup, sc.plat.ui.ExtensibleScreen, {
    className: 'sc.sfs.quote.manage.products.configurator.ItemConfiguratorPopup',
    getUIConfig: sc.sfs.quote.manage.products.configurator.ItemConfiguratorPopupUIConfig,
    namespaces: {
        target: [],
        source: []
    },
    baseUrl : "/sfs/quotes/configuremodel.do",
	retUrl : sc.sfs.helper.AppHelper.getCompleteURLForPost("/sfs/quotes/bomhandler.do"),
     getHtmlContent : function() {
    	 var html = "<IFRAME name='configIframe' STYLE='width:790px;height:430px;'/>";
 		return html;
 	},
 	postToIframe : function (){
     	var t =1;
     	var inputObj = this.inputObj;
     	var oLine = inputObj.OrderLine;
     	var pInfo = oLine.Item.PrimaryInformation;
     	var configurationKey = oLine.ConfigurationKey;
     /*	var bomXML;
     	if(oLine.Item.BOMXML)
     	{
     		bomXML = oLine.Item.BOMXML;
     	}*/
     	if(!configurationKey){
     		// there is no configuration key at line. Check Item
     	if(pInfo.ConfigurationKey){
     	// this is configured
     		configurationKey = pInfo.ConfigurationKey
     	}
     	}
     /*	var inputObjUpdated = {};
    		inputObjUpdated.OrderLine={};
    		inputObjUpdated.OrderLine.Key=this.inputObj.OrderLine.Key;*/
		
		//this.inputObj has cyclic property call 'items'. Making copy of 'this.inputObj' without this cyclick property.	
		var newObj = {};
		for (var p in this.inputObj) {
			if (p !== "items") {
				newObj[p] = this.inputObj[p];
			}
		}
			

    	var cnfg = {
					ReturnURL : this.retUrl,
					inputObj : Ext.encode(newObj),
					customerId : oLine.CustomerID,
					currency : oLine.Currency,
					//configXML:bomXML,
					configurationKey:configurationKey,
					organizationCode: oLine.SellerOrganizationCode,
					EnterpriseCode: oLine.EnterpriseCode,
					ConfigurationDate:inputObj.ConfigurationDate,
					IgnoreCustomerEntitlements:inputObj.IgnoreCustomerEntitlements
				};
    	if(!configurationKey || configurationKey==''){
    		cnfg.Model = pInfo.ConfigurationModelName;
    	}
    	sc.plat.FormUtils.request({
			url : sc.sfs.helper.AppHelper.getCompleteURLForPost(this.baseUrl),
			method : 'POST',
			params : cnfg,
			target : 'configIframe'

		});
	}
});
Ext.reg('ItemConfigPopup', sc.sfs.quote.manage.products.configurator.ItemConfiguratorPopup);
